package org.greenstone.gsdl3.gs3build.metadata;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.NamedNodeMap;

import java.util.List;
import java.util.Map;
import java.util.ArrayList;
import java.util.HashMap;

import org.greenstone.gsdl3.gs3build.schema.Schema;
import org.greenstone.gsdl3.gs3build.schema.SchemaNode;

public class MetaElement
{
	Map    attributes;
	List   children;
	String name;

	public MetaElement(Element element, Schema schema)
	{	
		// basic setup
		this.attributes = new HashMap();
		this.children   = new ArrayList();
		this.name = element.getNodeName();
		StringBuffer contentBuffer = new StringBuffer();
		
		// split the name into namespace/workspace
		String workSpace = SchemaNode.getNamespace(name);
		name = SchemaNode.getElementName(name);

		// get attributes
		NamedNodeMap attributes = element.getAttributes();
		for (int a = 0; a < attributes.getLength(); a ++)
		{	Node attribute = attributes.item(a);

			this.attributes.put(attribute.getNodeName(), attribute.getNodeValue());
		}

		// get children
		NodeList children = element.getChildNodes();
		for (int c = 0; c < children.getLength(); c++)
		{	Node child = children.item(c);

			if (child.getNodeType() == org.w3c.dom.Node.ELEMENT_NODE)
			{	// make a child
				if (contentBuffer.length() > 0) {
					this.children.add(contentBuffer.toString());
					contentBuffer.setLength(0);
				}
				Object childElement = new MetaElement((Element) child, schema);
				this.children.add(childElement);
			}
			else
			{	// append to content if not an element - this may be wasteful & type of
				// element should be checked
 				contentBuffer.append(child.getNodeValue());
			}
		}
		if (contentBuffer.length() > 0) {
			this.children.add(contentBuffer.toString());
		}
	}
}